#include "Appevent.ch"
#include "Font.ch"
#include "Gra.ch"
#include "Xbp.ch"


PROCEDURE Main
   LOCAL nEvent, mp1, mp2, oXbp
   LOCAL dlg

   dlg := CreateAppWindow()

   * This injects the ribbon. Parameters: Xbase Dialog to be ribbonized, Name of Ribbon Resource, CallbackHandler object
   RibbonizeXbDialog(dlg,"APPLICATION_RIBBON",RibbonCallbacks():New())

   DO WHILE .T.
      nEvent := AppEvent( @mp1, @mp2, @oXbp )
      oXbp:HandleEvent( nEvent, mp1, mp2 )
   ENDDO

RETURN

FUNCTION AppSys
RETURN NIL

FUNCTION AppQuit
   QUIT
RETURN NIL

FUNCTION CreateAppWindow
   LOCAL oDlg, oXbp, drawingArea, oGroup

   oDlg := XbpDialog():new( AppDesktop(), , {3,30}, {534,480}, , .F.)
   oDlg:taskList := .T.
   oDlg:gridMove := .T.
   oDlg:title    := "The First Ever Ribbonized Xbase Dialog"
   oDlg:close    := {|| AppQuit() }
   oDlg:create()

   drawingArea := oDlg:drawingArea

   oXbp := XbpStatic():new( drawingArea, , {50,350}, {300,50} )
   oXbp:caption := "Hello !"
   oXbp:type := XBPSTATIC_TYPE_TEXT
   oXbp:create()
   oXbp:setColorBG(GRA_CLR_RED)

   oXbp := XbpStatic():new( drawingArea, , {50,250}, {300,50} )
   oXbp:caption := "Thanks !"
   oXbp:type := XBPSTATIC_TYPE_TEXT
   oXbp:create()
   oXbp:setColorBG(GRA_CLR_GREEN)

   oXbp := XbpPushButton():new( drawingArea, , {12,12}, {130,24} )
   oXbp:caption := "Give me Ribbons!"
   oXbp:clipSiblings := .T.
   oXbp:create()
   * oXbp:activate := {|| PostAppEvent( xbeP_Close,,, oDlg ) }
   * oXbp:activate := {|| PostMessage(dlg:getHWND(),execCbMessage,0,0) }


   oDlg:show()

   SetAppWindow( oDlg )
   SetAppFocus( oDlg )

RETURN oDlg




* The RibbonCallbacks object implements a simlified IUICommandHandler interface

CLASS RibbonCallbacks
  EXPORTED:
   METHOD Execute
   METHOD UpdateProperty
ENDCLASS

METHOD RibbonCallbacks:Execute(commandId,verb,keyName,currentValue,commandExecutionProperties)
   DebugMessage(SVI("! Execute cmd=&1, verb=&2, key=&3, val=&4, cep=&5",commandId,verb,keyName,currentValue,commandExecutionProperties))
RETURN NIL

METHOD RibbonCallbacks:UpdateProperty(commandId,keyName,currentValue,newValue)
   DebugMessage(SVI("! UpdateProperty cmd=&1, key=&2, val=&3",commandId,keyName,currentValue))
   IF keyName == "TooltipDescription"
      newValue := "Aber bitte mit Tooltip und etwas Sahne"
   ENDIF
   IF keyName == "TooltipTitle"
      newValue := "On Top"
   ENDIF
RETURN NIL





